// this is an effect template. use it to start writing your own effects.

// -------------------------------------------------------------------------------------------------------------------------------------
// PARAMETERS:
// -------------------------------------------------------------------------------------------------------------------------------------

//transforms
float4x4 tWIT: WORLDINVERSETRANSPOSE;
float4x4 tWVP: WORLDVIEWPROJECTION;

float Near <
    string UIName = "Near Depth";
    string UIWidget = "slider";
    float UIMin = 0.001;
    float UIMax = 70.0;
    float UIStep = 0.001;
> = 1.0f;

float Far <
    string UIName = "Far Depth";
    string UIWidget = "slider";
    float UIMin = 0.3;
    float UIMax = 120.0;
    float UIStep = 0.001;
> = 10.0f;


// -------------------------------------------------------------------------------------------------------------------------------------
// VERTEXSHADERS
// -------------------------------------------------------------------------------------------------------------------------------------

struct VS_OUTPUT
{
    float4 Pos  : POSITION;
    float4 col : COLOR0;
    float4 Norm : NORMAL;
};

VS_OUTPUT VS(VS_OUTPUT In,
    float4 Pos  : POSITION,
    float2 TexC : TEXCOORD)
{
    //inititalize all fields of output struct with 0
    VS_OUTPUT Out = (VS_OUTPUT)0;
    float4 Po = float4(Pos.xyz,1.0);
    float4 Ph = mul(Po,tWVP);
    Out.Pos = Ph;
    // these three could be "static"
    float TrueFar = max(Near,Far);
    float TrueNear = min(Near,Far);
    float DepthRange = max((TrueFar-TrueNear),0.01);
    float g = (Ph.z-TrueNear)/DepthRange;
    Out.col = float4(g,g,g,1.0);
    //transform position
    Pos = mul(Pos, tWVP);

    Out.Pos  = Pos;
    return Out;
}
// -------------------------------------------------------------------------------------------------------------------------------------
// TECHNIQUES:
// -------------------------------------------------------------------------------------------------------------------------------------

technique TSimpleShader
{
    pass MakeGrayMap <
    > {
	VertexShader = compile vs_3_0 VS()  ;
        }
}
